import { usePolling } from "../hook/api";
import { useLeaderboardStateReducer, useLeaderboardGuideReducer } from '../reducer/leaderboard';

export default function useLeaderboardApi() {
    const [state, dispatchState] = useLeaderboardStateReducer();
    const [guide, dispatchGuide] = useLeaderboardGuideReducer();

    const useTablePolling = (config) => {
        const onPolling = (isPolling) => dispatchGuide({ type: 'next', isPolling });
        const onSuccess = (table) => dispatchState({type: 'next', table });

        usePolling('/api/leaderboard', { onSuccess, onPolling }, config.intervalMode(300));
    }

    return {
        state,
        guide,
        dispatchGuide,
        api: {
            useTablePolling
        }
    }
}